package org.hidetake.jsonizer.test;

import java.io.IOException;
import java.io.StringWriter;
import java.io.Writer;
import java.util.ArrayList;
import java.util.List;
import java.util.logging.Logger;

import net.arnx.jsonic.JSON;

import org.slim3.controller.Controller;
import org.slim3.controller.Navigation;

public class JsonicController extends Controller
{

	public static class Hoge
	{
		private int count;
		private String message;
		public int getCount()
		{
			return count;
		}
		public void setCount(int count)
		{
			this.count = count;
		}
		public String getMessage()
		{
			return message;
		}
		public void setMessage(String message)
		{
			this.message = message;
		}
	}

	private static final Logger logger = Logger.getLogger(JsonicController.class.getName());
	private long time;

	@Override
	public Navigation run() throws Exception
	{
		measure();
		measure();
		measure();
		return null;
	}

	private void measure() throws IOException
	{
		Writer stringWriter = new StringWriter();
		List<?> list = makeList(asInteger("c"));
		start();
		JSON.encode(list, stringWriter);
		logger.info(endMs());
	}

	protected List<?> makeList(int size)
	{
		List<Object> list = new ArrayList<Object>();
		for(int i = 0; i < size; i++) {
			Hoge hoge = new Hoge();
			hoge.setCount(i);
			hoge.setMessage("OK");
			list.add(hoge);
			list.add(i);
		}
		return list;
	}

	protected void start()
	{
		time = System.currentTimeMillis();
	}

	protected long end()
	{
		return System.currentTimeMillis() - time;
	}

	protected String endMs()
	{
		return end() + " ms";
	}

}
