package org.hidetake.jsonizer.test;

import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.logging.Logger;

import org.hidetake.jsonizer.JsonWriter;
import org.hidetake.jsonizer.PropertyGetter;
import org.slim3.controller.Controller;
import org.slim3.controller.Navigation;

public class JsonizeController extends Controller
{

	public static class Hoge
	{
		private int count;
		private String message;
		public int getCount()
		{
			return count;
		}
		public void setCount(int count)
		{
			this.count = count;
		}
		public String getMessage()
		{
			return message;
		}
		public void setMessage(String message)
		{
			this.message = message;
		}
	}

	private static final Logger logger = Logger.getLogger(JsonizeController.class.getName());
	private long time;

	@Override
	public Navigation run() throws Exception
	{
		measure();
		measure();
		measure();
		return null;
	}

	private void measure() throws IOException
	{
		Appendable stringWriter = new StringBuilder();
		List<?> list = makeList(asInteger("c"));
		start();
		Map<Class<?>, PropertyGetter<?>> map = new HashMap<Class<?>, PropertyGetter<?>>();
		map.put(Hoge.class, new PropertyGetter<Hoge>()
		{
			public void get(Hoge m) {
				property("count", m.getCount());
				property("message", m.getMessage());
			};
		});
		JsonWriter jsonWriter = new JsonWriter(stringWriter);
		jsonWriter.write(list);
		logger.info(endMs());
	}

	protected List<?> makeList(int size)
	{
		List<Object> list = new ArrayList<Object>();
		for(int i = 0; i < size; i++) {
			Hoge hoge = new Hoge();
			hoge.setCount(i);
			hoge.setMessage("OK");
			list.add(hoge);
			list.add(i);
		}
		return list;
	}

	protected void start()
	{
		time = System.currentTimeMillis();
	}

	protected long end()
	{
		return System.currentTimeMillis() - time;
	}

	protected String endMs()
	{
		return end() + " ms";
	}

}
